#include <unistd.h>
#include <memory.h>
#include "../curses.h"
#include "../gdbm-local.h"
#include "../struktury_dbm.h"
#include "../lib_dbm.h"

int smaz_zaznam(DBM * dbm_ptr, int ukazatel)
{
    struct zaznam nacteno;
    datum klic;
    datum data;
    WINDOW *new_win;
    wint_t klavesa;
    int i = 0;


    for (klic = dbm_firstkey(dbm_ptr); klic.dptr;
	 klic = dbm_nextkey(dbm_ptr)) {
	if (i == ukazatel) {
	    data = dbm_fetch(dbm_ptr, klic);
	    memcpy(&nacteno, data.dptr, data.dsize);
	    break;
	}
	i++;
    }
    if (i != ukazatel)
	return 1;

    new_win = newwin(4, COLS, (int) LINES / 2 - 1, 0);
    box(new_win, ACS_VLINE, ACS_HLINE);
    mvwprintw(new_win, 0, 2, " DELETE ");
    mvwprintw(new_win, 1, 1, "%4ls %-40ls %5i %5i %6i %6i", nacteno.kod,
	      nacteno.nazev, nacteno.semestr, nacteno.vsemestru,
	      nacteno.kreditu, nacteno.znamka);
    clear();
    refresh();
    do {
	mvwprintw(new_win, 2, 1, "Smazat [Ano,Ne] ?");
	wrefresh(new_win);
	(void) get_wch(&klavesa);
	switch (klavesa) {
	case L'n':
	case L'N':
	    delwin(new_win);
	    return 0;
	    break;
	case L'a':
	case L'A':
	    data.dsize = wcslen(nacteno.kod) * sizeof(nacteno.kod[0]);
	    if (dbm_delete(dbm_ptr, data)) {
		endwin();
		fprintf(stderr, "Erorr mazani z databaze\n");
		sleep(2);
		refresh();
		delwin(new_win);
		return 1;
	    } else {
		delwin(new_win);
		return 0;
	    }
	    break;
	}
    }
    while (1);

    delwin(new_win);
    return 0;
}
